package com.shcd.tcpais.entity;

import com.shcd.tcpais.common.annotation.AISMsgType;
import com.shcd.tcpais.common.annotation.AISMsgTypeMarge;
import com.shcd.tcpais.common.annotation.Need;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 类名:@Name - AisAnalyBase
 * 功能描述:@Function Description<>
 * 日期:@Date - 2025/1/17 11:00
 * 作者:@Created by zrj
 */
@Data
public class AisAnalyBase implements Serializable {
    private Date strTime;         //time
    private Integer messageType;
    public String oldStr ;
    public String rootStr ;

    @AISMsgType(type = {1,4,5,18}, position ={6,8},merge = true )
    @AISMsgTypeMarge(mergeName ="合并24属性",mergeType =24,type = {0,1},position = {6,8})
    private String repeatIndicator;
    @AISMsgType(type = {1,4}, position ={148, 149} )
    private String raimFlag;//    private String raim_flag;
    @AISMsgType(type = {1,4,18}, position ={149, 168} )
    private String communicationState;//    private String communication_state;
    @AISMsgType(type = {1,4,5,18}, position ={60, 61,78,79,240, 270,56, 57},function = "position5or24")
    @AISMsgTypeMarge(mergeName ="合并24属性",mergeType =24,type = {1},position = {132, 162},function = "position5or24")
    private String position;//Position
    @AISMsgType(type = {1,4}, position ={145, 148,138,148} )
    private String spare;//Spare
    @AISMsgType(type = {1,18}, position ={137, 143,133, 139} )
    private String timeStamp;// time_stamp
    //   ------------------------------------------------GPSINFO
    @AISMsgType(type = {1,4,5,18}, position ={0,6} ,merge = true)
    @AISMsgTypeMarge(mergeName ="合并24属性",mergeType =24,type = {0,1},position = {0,6})
    private String messageId; //    message_id
    @AISMsgType(type = {1,4,5,18}, position ={8,38},function = "BitToMMSI",merge = true)
    @AISMsgTypeMarge(mergeName ="合并24属性",mergeType =24,type = {0,1},position = {8,38},function = "BitToMMSI")
    @Need(name = "mmsi九位码")
    private String mmsi;
    @AISMsgType(type ={1,4,18}, position ={61, 89,79,107,57,85},function = "BitToLongitudeLatitudeDouble")
    private Double longitude;
    @AISMsgType(type = {1,4,18}, position ={89, 116,107,134,85,112},function = "BitToLongitudeLatitudeDouble")
    private Double latitude;
    @AISMsgType(type = {1,18}, position ={50, 60,46, 56},function = "printSOGDouble")
    private Double sog;             //velocity
    @AISMsgType(type = {1,18}, position ={116, 128,112, 124},function = "printCOGDouble")
    private Double cog;             //direction
    @AISMsgType(type = {1,18}, position ={128, 137,124, 133} )
    private String trueHeading;    //direction true_heading
    @AISMsgType(type = {4,5}, position ={134,138,270,274},function = {"BitToMessage","BitToMMSI"})
    private String positionFixing;//PositionFixing

    private Double mapx;            //mapx

    private Double mapy;            //mapy

    private Integer INFSOURCE = 1;

}
