package com.shcd.tcpais.service.impl;

import com.alibaba.fastjson.JSON;
import com.shcd.tcpais.entity.BoatInfoEntity;
import com.shcd.tcpais.config.RedisCache;
import com.shcd.tcpais.service.AisAnalysisService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.ObjectUtils;

import java.util.concurrent.TimeUnit;

/**
 * 类名:@Name - AisAnalysisServiceImpl
 * 功能描述:@Function Description<>
 * 日期:@Date - 2025/1/18 14:33
 * 作者:@Created by zrj
 */
@Slf4j
@Service
public class AisAnalysisServiceImpl implements AisAnalysisService {

    @Autowired
    private RedisCache redisCache;

    @Override
    public void saveAisAnalysis(BoatInfoEntity boatInfoEntity) {
        if (ObjectUtils.isEmpty(boatInfoEntity)){
            log.info("无数据");
        }
        redisCache.setCacheObject(boatInfoEntity.getId()+"_zy", JSON.toJSONString(boatInfoEntity),10, TimeUnit.MINUTES);
    }
}
