package com.shcd.tcpais.util;

import com.shcd.tcpais.common.annotation.AISMsgType;
import com.shcd.tcpais.common.annotation.AISMsgTypeMarge;
import com.shcd.tcpais.entity.AisAnalyBase;
import lombok.extern.slf4j.Slf4j;

import java.lang.reflect.Field;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 类名:@Name - AISMessageUtil
 * 功能描述:@Function Description<>
 * 日期:@Date - 2025/1/17 10:57
 * 作者:@Created by zrj
 */
@Slf4j
public class AISMessageUtil {
    public static void main(String[] args) {
        ObjectAisMsg aisAnalyBase=new ObjectAisMsg();
        Field[] fields= aisAnalyBase.getClass().getDeclaredFields();
        List<Field> fieldList= Arrays.asList(fields);
//        System.out.println();
//        //获取本类型的所有属性
//        List<Field> fieldList1=fieldList.stream()
//                .filter(i->i.getAnnotation(AISMsgType.class)!=null)
//        .filter(i-> (Arrays.stream(i.getAnnotation(AISMsgType.class).type()).boxed().collect(Collectors.toList()).contains(18))).collect(Collectors.toList());
        System.out.println(fieldList.stream().map(Field::getName).collect(Collectors.toList()));
    }

    public static AisAnalyBase EncodeMessage(Integer typecode, String aisMessage) throws Exception {
        return   analyMsg(new ObjectAisMsg(),  typecode, aisMessage);
    }

    /**
     * 解析数据
     * @param om
     * @param typecode
     * @param aisMessage
     * @return
     */
    private static ObjectAisMsg  analyMsg(ObjectAisMsg om, Integer typecode, String aisMessage)
    {
        Field[] fields= om.getClass().getDeclaredFields();
        om=analyField(fields, om, typecode,  aisMessage);
        Field[] basefields= om.getClass().getSuperclass().getDeclaredFields();
        om=analyField(basefields, om, typecode,  aisMessage);
        return om;
    }

    private static ObjectAisMsg  analyField( Field[] fields,ObjectAisMsg om, Integer typecode, String aisMessage){
        log.info("===   处理类型"+typecode);
        List<Field> fieldList= Arrays.asList(fields);
        //获取本类型的所有属性
        List<Field> fieldList1=fieldList.stream()
                .filter(i->i.getAnnotation(AISMsgType.class)!=null)
                .filter(i-> (Arrays.stream(i.getAnnotation(AISMsgType.class).type()).boxed().collect(Collectors.toList()).contains(typecode))).collect(Collectors.toList());
        if (fieldList1!=null && fieldList1.size()>0) {
            fieldList1.stream().forEach(i ->
            {
                i.setAccessible(true);
                int[] position = i.getAnnotation(AISMsgType.class).position();//位置可以多个
                int[] types=i.getAnnotation(AISMsgType.class).type(); //类型，可以多个
                String[] oldFunction = i.getAnnotation(AISMsgType.class).function(); //处理方法可以多个
                log.info("===   字段"+i.getName()+"  position：{} types:{} oldFunction:{}",position,types,oldFunction);
                if (position.length==2)
                {
                    for (int j=0;j<types.length;j++) {
                        if (types[j]==typecode) {
                            String function=oldFunction[0];
                            if (oldFunction.length==types.length)
                            {
                                function=oldFunction[j];
                            }
                            try {
                                i.set(om, getData(position, typecode, function, aisMessage));
                            } catch (IllegalAccessException e) {
                                log.info("===   赋值出错" + e.getMessage());
                            }
                        }
                    }
                }else {
                    int[] location ={position[0],position[1]};
                    for (int j=0;j<types.length;j++)
                    {
                        if (types[j]==typecode)
                        {
                            String function=oldFunction[0];
                            if (oldFunction.length==types.length)
                            {
                                function=oldFunction[j];
                            }

                            if (position.length>(j * 2)) {
                                location[0] = position[j * 2];
                                location[1] = position[j * 2+1];
                            }
                            try {
                                i.set(om, getData(location, typecode, function, aisMessage));
                            } catch (IllegalAccessException e) {
                                log.info("===   赋值出错" + e.getMessage());
                            }
                        }
                    }
                }
            });
            om.setMessageType(typecode);
        }else {
            //第二种注解分析，组合类型
            List<Field> margeFileds=fieldList.stream()
                    .filter(i->i.getAnnotation(AISMsgTypeMarge.class)!=null)
                    .filter(i-> (Arrays.stream(i.getAnnotation(AISMsgTypeMarge.class).mergeType()).boxed().collect(Collectors.toList()).contains(typecode))).collect(Collectors.toList());
            margeFileds.forEach(i->{
                int[] position = i.getAnnotation(AISMsgTypeMarge.class).position();
                String[] oldFunction = i.getAnnotation(AISMsgTypeMarge.class).function();
//                AISMsgTypeMarge(mergeName ="合并24属性",mergeType =24,type = {0,1},position = {8,38},function = "BitToMMSI")
                int[] types= i.getAnnotation(AISMsgTypeMarge.class).type(); //此type是逻辑分支
                log.info("===   字段"+i.getName()+"  position：{} types:{} oldFunction:{}",position,types,oldFunction);
                i.setAccessible(true);
                if (position.length==2) { //处理所有类型都对应一个地址解析的情况
                    for (int j=0;j<types.length;j++) {
                        String function = oldFunction[0];
                        if (oldFunction.length==types.length) {
                            function = oldFunction[j];
                        }
                        String type = String.valueOf(types[j]);
                        if (type.equals(CommonUtil.BitToMMSI(aisMessage.substring(38, 40)))) {
                            try {
                                i.set(om, getData(position, typecode, function, aisMessage));
                            } catch (IllegalAccessException e) {
                                log.info("===   赋值出错" + e.getMessage());
                            }
                        }
                    }
                }else {
                    int[] location ={position[0],position[1]};
                    for (int j = 0; j < types.length; j++) {
                        if (types[j] == typecode) {
                            String function = oldFunction[0];
                            if (oldFunction.length==types.length) {
                                function = oldFunction[j];
                            }
                            String type = String.valueOf(types[j]);
                            if (position.length>(j * 2)) {
                                location[0] = position[j * 2];
                                location[1] = position[j * 2 + 1];
                            }
                            if (type.equals(CommonUtil.BitToMMSI(aisMessage.substring(38, 40)))) {
                                try {
                                    i.set(om, getData(location, typecode, function, aisMessage));
                                } catch (IllegalAccessException e) {
                                    log.info("===   赋值出错" + e.getMessage());
                                }
                            }
                        }
                    }
                }
            });
            //目前只有24需要给5，后续可以再更改
            om.setMessageType(5);
        }
        return om;
    }


    private static Object getData(int[] position,Integer typecode, String oldFunction, String aisMessage)
    {
        log.info("   ===   最后使用：position:{} types:{},oldFunction:{}",position,typecode,oldFunction);
        String all = aisMessage.substring(position[0], position[1]);
        switch (oldFunction){
            case "BitToMessage" :
                return CommonUtil.BitToMessage(all);
            case "BitToMMSI" :
                return CommonUtil.BitToMMSI(all);
            case "printNavStatus" :
                return CommonUtil.printNavStatus(all);
            case "BitToLongitudeLatitudeDouble" :
                return CommonUtil.BitToLongitudeLatitudeDouble(all);
            case "printSOGDouble" :
                return CommonUtil.printSOGDouble(all);
            case "printCOGDouble" :
                return CommonUtil.printCOGDouble(all);
            case "MESStoShipType" :
                return CommonUtil.MESStoShipType(all);
            case "setBoatLength" :
                int A = Integer.parseInt(CommonUtil.BitToMessage(all.substring(0, 9)));
                int B = Integer.parseInt(CommonUtil.BitToMessage(all.substring(9, 18)));
                return A+B;
            case "setBoatWidth" :
                int C = Integer.parseInt(CommonUtil.BitToMessage(all.substring(18, 24)));
                int D = Integer.parseInt(CommonUtil.BitToMessage(all.substring(24, 30)));
                return C+D;
            case "position5or24" :
                if (typecode==5|| typecode==24)
                {
                    return all;
                }else {
                    return CommonUtil.BitToMessage(all);
                }
            case "createString" :
                return CommonUtil.createString(all);
            case "ETA2DateStr" :
                return CommonUtil.ETA2DateStr(all);
            case "parseDouble" :
                return Double.parseDouble(CommonUtil.BitToMessage(aisMessage.substring(294, 302))) / 10;
            case "name" :
                String name=CommonUtil.createString(all);
                if (name.trim().length() < 3 || (all.length() > 6 && "000000".equals(all.substring(0, 6)))) {
                    return null;
                }else {
                    return name.trim();
                }
            default:
                return null;
        }
    }
}
