package com.shcd.tcpais.util;

import com.shcd.tcpais.common.AisAnalysisEnum;
import com.shcd.tcpais.entity.AisAnalyBase;
import com.shcd.tcpais.entity.BoatInfoEntity;
import com.shcd.tcpais.entity.GHAisInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;

/**
 * 类名:@Name - AisAnalysisUtil
 * 功能描述:@Function Description<>
 * 日期:@Date - 2025/1/17 11:01
 * 作者:@Created by zrj
 */
@Slf4j
@Component
public class AisAnalysisUtil {


    public static void main(String args[]) {
        try {
//            类型为4的解析正确
//String msg="!AIVDM,1,1,,A,403t>6ivFS:JH``aDrA`0io00@>n,0*0F";
// String msg="!AIVDM,1,1,,A,403t>=AvFS:Jd`bfmVAegsW00HJF,0*2C";
//            类型18的解析正确
//String msg="!AIVDM,1,1,,B,B6:c3sP0=R:Ev24KwF0n40140000,0*6D";
//String msg="!AIVDM,1,1,,B,B6:hPK@002:I6<4Kfhh03h24SP00,0*64";
//String msg="!AIVDM,1,1,,B,C6:WE?@002:Ea5TKwSbigwe2jc06@2L?0`2C1SUi1110S3062S07,0*19";
//               类型为1的解析正确
//  String msg="!AIVDM,1,1,,B,16:V2ahk00`aaNrAfR>E;gv240Cn,0*7D";
// String msg="!AIVDM,1,1,,A,16:c4m00008aAC:Agsso0@0t0000,0*3D";
// String msg="!AIVDM,1,1,,A,16:d>A@P008a74hAgEv000Hp1P00,0*5E";
// String msg="!AIVDM,1,1,,B,36:d>>PP008a:mvAgo;N4?v00000,0*77";
            //            解析错误不一致
//String msg="!AIVDM,2,1,3,B,56:bdgh000030000001`PD`T4pMPTpMTW37;401610p672M;j6Dj0CQj0B@0,0*64";
//String msg="!AIVDM,1,1,,B,H6:V`v@`TpN0P4pN3;3?P000002,2*55";

            String msg="!AIVDM,1,1,,A,15SKkH01AN`ejuRAmQgm;4:f0@?6,0*02";
            System.out.println(new AisAnalysisUtil().judgeCRC(msg));
        } catch (Exception ex) {
            ex.printStackTrace();
//            String exStr = ex.getMessage();
//            System.out.println(exStr);
        }
    }

    public BoatInfoEntity explanation(String msg){
        List<GHAisInfo> ghAisInfoList = new ArrayList<>();
        try {
            AisAnalyBase analyBase = new AisAnalysisUtil().judgeCRC(msg);
            log.info("解析后：{}",analyBase);
            BoatInfoEntity boatInfoEntity = new BoatInfoEntity();
            if (analyBase.getMmsi() != null){
                boatInfoEntity.setId(analyBase.getMmsi());
            }

            GHAisInfo ghAisInfo = new GHAisInfo();
            if (analyBase.getLatitude() != null){
                ghAisInfo.setLatitude(new BigDecimal(analyBase.getLatitude()));
            }
            if (analyBase.getLongitude() != null){
                ghAisInfo.setLongitude(new BigDecimal(analyBase.getLongitude()));
            }
            if (analyBase.getMapx() != null){
                ghAisInfo.setMapx(new BigDecimal(analyBase.getMapx()));
            }
            if (analyBase.getMapy() != null){
                ghAisInfo.setMapy(new BigDecimal(analyBase.getMapy()));
            }
            ghAisInfoList.add(ghAisInfo);
            boatInfoEntity.setAisData(ghAisInfoList);
            boatInfoEntity.setPointNum(ghAisInfoList.size());
            log.info(boatInfoEntity.toString());
            return boatInfoEntity;
        } catch (Exception e) {
            log.info(e.getMessage());
        }
        return null;
    }



    public static AisAnalyBase judgeCRC(String str) throws Exception {
        String a;
        //对传入字符串进行解析,无法解析 throw Exception
        a = getInStr(str);
        AisAnalyBase om;
        try {
            String[] tempStr = a.split("[*]");

            if (tempStr.length < 2) {
                throw new Exception("分割后数据不足!数据源:" + str);
            }
            try {
                if (!CommonUtil.createCRC(tempStr[0]).trim().equals(tempStr[1].trim())) {
                    throw new Exception("分割后数据验证不正确!数据源:" + str + " "
                            + CommonUtil.createCRC(tempStr[0]) + "!=" + tempStr[1]);
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
            om = parserAISMsg(tempStr[0], str);
            if (om != null) {
                om.rootStr = str;
                //全部new时间不使用发送时间
                //om.setStrTime(strTime);
            }else {
                log.info("==  没有解析出数据");
                return null;
            }
            // 对转换的数据进行验证
            if (om.getMessageType() == 5) {
                om = checkMesBoat((ObjectAisMsg) om, str, true);
            } else if (om.getMessageType()==1 ||  om.getMessageType()==18) {
                //当方向为511时为默认 null;
                if ("511".equals(om.getTrueHeading())) {
                    om.setTrueHeading(null);
                }
                om = checkMesGPS((ObjectAisMsg) om, str, true);
            }
//            else if (om instanceof ObjAISMessage19) {
//                ((ObjAISMessage19) om).setOmBoat((ObjAISMessage5) checkMesBoat(((ObjAISMessage19) om).getOmBoat(), str, false));
//                ((ObjAISMessage19) om).setOmGps((ObjAISMessageGPSINFO) checkMesGPS(((ObjAISMessage19) om).getOmGps(), str, false));
//            }
            return om;
        } catch (Exception ex) {
            throw ex;
        }
    }

    /******************************************************
     * getInStr
     * 得到正确的输入数据
     * 没有解析成功则抛出异常 Exception;
     ******************************************************/
    private static String getInStr(String str) throws Exception {

        if (str.length() < 8) {
            throw new Exception("消息长度过短.数据源; " + str);
        }
        /*
         * 检查是否为服务器返回的消息.
         *    KeepAlive ErrorMes 等消息的处理
         */
//        if ("$".equals(str.substring(0, 1)) && "PSTT".equals(str.substring(1, 5))) {
//            serverMes(str);
//            // LogManager.appendMethodB(LogManager.getLogFilePath().toString(), str + ". from Exception \r\n");
//        }
        //检查3至6
        if (checkInStr(str, 3, 6)) {
            return str.substring(1, str.length());
        }
        //检查2至5
        if (checkInStr(str, 2, 5)) {
            return str.substring(1, str.length());
        }
        //使用!
        if (catStr(str, "!")) {
            return str.split("!")[str.split("!").length - 1];
        }
        //使用$
        if (catStr(str, "$")) {
            return str.split("$")[str.split("$").length - 1];
        }
        //使用&
        if (catStr(str, "&")) {
            return str.split("&")[str.split("&").length - 1];
        }
        //抛出异常
        throw new Exception("数据格式不正确.数据源:" + str);
    }

    /***********************************************
     * catStr
     * 使用 cat 切割 str
     *       长度正确 : 返回checkInStr验证结果;
     *       长度不正确: 返回 false;
     ***********************************************/
    private static boolean catStr(String str, String cat) throws Exception {
        String[] strAr = str.split(cat);
        return checkInStr(strAr[strAr.length - 1], 2, 5);
    }

//    /**********************************************************
//     * serverMes
//     * 服务器返回消息的使用;
//     * 先验证,之后加入log,和jList;
//     **********************************************************/
//    private void serverMes(String str) throws Exception {
//        //去除最先的$
//        str = str.substring(1);
//        String[] arrStr = str.split("[*]");
//        if (Common.createCRC(arrStr[0]).equals(arrStr[1])) {
//            LogUtil.write(LogUtil.EXCEPTION, str + " . from serverMessage \r\n");
//
//        } else {
//            throw new Exception("serverMes 验证失败. 消息源:" + str);
//        }
//    }

    /*******************************************************
     * CheckInStr
     * 是否为正确的输入数据 return : 是true , 不是 false
     *******************************************************/
    private static boolean checkInStr(String str, int iBen, int iEnd) {
        return ((str.length() > 4
                && ("VDM".equals(str.substring(iBen, iEnd))
                || "ZDA".equals(str.substring(iBen, iEnd))
                || "VDO".equals(str.substring(iBen, iEnd)))));
    }

    /*******************************************************
     * checkMesGPS
     * 对船名信息进行验证
     * 参数om: 要验证的对象
     * 参数str: 接收的消息str
     * 参数isThrowEx: 错误时是否抛出异常,不抛出时return null;
     *******************************************************/
    private static ObjectAisMsg checkMesBoat(ObjectAisMsg om, String str, boolean isThrowEx) throws Exception {
        if (om!=null && om.getMessageType()==5) {
            try {
                // id 不为9位
                if (om.getMmsi() == null
                        || om.getMmsi().length() == 0) {
                    throw new Exception("解析后 MMSI 不为9位,数据源:" + str+"\r\n");
                }
                // name length 长度不够;
                if (om.getName() == null
                        || om.getName().length() < 3) {
                    throw new Exception("解析后船名长度过短,数据源:" + str
                            + " 解析之后aisMessage:\r\n");
                }
                om.setName(StringReplace.Replace(om.getName()));
//            if (charInBoatName(om.getName())) {
//                return null;
//            }
            } catch (Exception ex) {
                if (isThrowEx) {
                    throw ex;
                } else {
                    return null;
                }
            }
            return om;
        }else {
            return null;
        }
    }

    /************************
     * checkBoatName
     *  检查BoatName是否包含特殊字符
     *   return true; 有特殊字符
     *          false: 没有
     ***********************/
//    private boolean charInBoatName(String str) {
//        for (int i = 0; i < Util.charArr.length; i++) {
//            if (str.contains(Util.charArr[i])) {
//                return true;
//            }
//        }
//        return false;
//    }

    /*******************************************************
     * checkMesGPS
     * 对GPS信息进行验证
     * 参数om: 要验证的对象
     * 参数str: 接收的消息str
     * 参数isThrowEx: 错误时是否抛出异常,不抛出时return null;
     *******************************************************/
    private static AisAnalyBase checkMesGPS(ObjectAisMsg om, String str, boolean isThrowEx) throws Exception {
        // id 不为9位
        try {
            if (om.getMmsi() == null
                    || om.getMmsi().length() != 9) {
                throw new Exception("解析后 MMSI 不为9位,数据源: " + str
                        + "\t\n");
            }
            // id为00000000
            if (Integer.parseInt(om.getMmsi()) == 0) {
                throw new Exception("解析之后 MMSI为 000000000: " + str
                        + "\t\n");
            }

            // 经纬度为91或者181
            if (om.getLatitude() == 91.0
                    || om.getLongitude() == 181.0) {
                throw new Exception("解析之后 经纬度为(91,181) : " + str
                        + "\t\n");
            }

//            // 经为度区间不正确
//            if (om.getLatitude() < 25 || om.getLatitude() > 35
//                    || om.getLongitude() < 115 || om.getLongitude() > 125) {
//                throw new Exception("数据解析后经纬度区间不正确: " + str
//                        + " 解析之后aisMessage: " + aisMessage + "\t\n");
//            }


            // 对非上海海域的经纬度进行判断
            if (om.getLatitude() < AisAnalysisEnum.minLatitude.getValue() || om.getLatitude() > AisAnalysisEnum.maxLatitude.getValue()
                    || om.getLongitude() < AisAnalysisEnum.minLongitude.getValue() || om.getLongitude() > AisAnalysisEnum.maxLongitude.getValue()) {
                //经纬度的不再某范围内
                return null;
            }
        } catch (Exception ex) {
            if (isThrowEx) {
                throw ex;
            } else {
                return null;
            }
        }
        return om;
    }

    /*********************
     *
     * @param msg
     */
    private static synchronized AisAnalyBase parserAISMsg(String msg, String str) throws Exception {
        String[] msgArr = msg.split(",");
        StringBuilder  aisMessage = null;
        if (msgArr[2].equals("1")) {
            aisMessage = new StringBuilder();
        }
        for (int n = 0; n < msgArr[5].length(); n++) {
            String temp = msgArr[5].substring(n, n + 1);
            String atemp = CommonUtil.stringToBinary(temp);
            aisMessage.append(atemp);
        }
        for (int m = 0; m < Integer.parseInt(msgArr[6]); m++) {
            aisMessage.append("0");
        }
        if (msgArr[1].equals(msgArr[2])) {
            return getAISObject(aisMessage.toString(), str);
        }
        return null;
    }

    /*************************
     *  根据,串入的s_aisMessage返回 AIS对象
     *  第2个参数messageStr仅在异常时加入log
     */
    private static synchronized AisAnalyBase getAISObject(String s_aisMessage, String messageStr) throws Exception {
        if (s_aisMessage.length() < 5) {
            throw new Exception("解析后,aisMessage长度不足 5 ,数据源:" + messageStr
                    + " 解析之后 aisMessage:" + s_aisMessage);
            //return null;
        }
        String msgID = s_aisMessage.substring(0, 6);

        if (BitToMessage(msgID).equals("1") || BitToMessage(msgID).equals("2")
                || BitToMessage(msgID).equals("3")) {
            if (s_aisMessage.length() < 168) {
                throw new Exception("消息转换后长度不足,消息类型1,2,3,数据源:" + messageStr
                        + " 解析之后aisMessage: " + s_aisMessage);
                //    return null;
            }
            try {
                AisAnalyBase test = AISMessageUtil.EncodeMessage(1,s_aisMessage);
                test.oldStr = s_aisMessage;
                return test;
            } catch (Exception ex) {
                throw new Exception(ex);
            }
            //消息4
        } else if (BitToMessage(msgID).equals("4")) {
            if (s_aisMessage.length() < 168) {
                throw new Exception("消息转换后长度不足,消息类型4;,数据源:" + messageStr
                        + " 解析之后aisMessage: " + s_aisMessage);
            }
            try {
                return AISMessageUtil.EncodeMessage(4,s_aisMessage);
            } catch (Exception ex) {
                throw new Exception(ex);
            }
            //消息5
        } else if (BitToMessage(msgID).equals("5")) {
            if (s_aisMessage.length() < 424) {
                throw new Exception("消息转换后长度不足,消息类型5,数据源:" + messageStr
                        + " 解析之后aisMessage: " + s_aisMessage);
            }
            try {
                return AISMessageUtil.EncodeMessage(5,s_aisMessage);

            } catch (Exception ex) {
                throw new Exception(ex);
            }
            //消息18
        } else if (BitToMessage(msgID).equals("18")) {
            if (s_aisMessage.length() < 168) {
                throw new Exception("消息转换后长度不足,消息类型18,数据源:" + messageStr
                        + " 解析之后aisMessage: " + s_aisMessage);
            }
            try {
                System.out.println(s_aisMessage);
                return AISMessageUtil.EncodeMessage(18,s_aisMessage);

            } catch (Exception ex) {
                throw new Exception(ex);
            }
            //消息19
        } else if (BitToMessage(msgID).equals("19")) {
            if (s_aisMessage.length() < 312) {
                throw new Exception("消息转换后长度不足,消息类型19,数据源:" + messageStr
                        + " 解析之后aisMessage: " + s_aisMessage);
            }
            try {
                return  AISMessageUtil.EncodeMessage(18,s_aisMessage);

            } catch (Exception ex) {
                throw new Exception(ex);
            }
            //消息24
        } else if (BitToMessage(msgID).equals("24")) {
            if (s_aisMessage.length() < 160) {
                throw new Exception("消息转换后长度不足,消息类型18,数据源:" + messageStr
                        + " 解析之后aisMessage: " + s_aisMessage);
            }
            try {
                return  AISMessageUtil.EncodeMessage(24,s_aisMessage);

            } catch (Exception ex) {
                throw new Exception(ex);
            }
        } else {
            return null;
        }
    }

    /**
     * @param str
     * @return Message
     */
    private synchronized static String BitToMessage(String str) {
        BigInteger bi = new BigInteger(str, 2);
        return bi.toString(10);
    }
}
