package com.shcd.tcpais.util;

import com.shcd.tcpais.common.annotation.AISMsgType;
import com.shcd.tcpais.common.annotation.AISMsgTypeMarge;
import com.shcd.tcpais.entity.AisAnalyBase;
import lombok.Data;
import lombok.ToString;

import java.util.Date;

/**
 * 类名:@Name - ObjectAisMsg
 * 功能描述:@Function Description<>
 * 日期:@Date - 2025/1/17 10:58
 * 作者:@Created by zrj
 */
@Data
@ToString(callSuper = true)
public class ObjectAisMsg extends AisAnalyBase {
    //   --------------------------------------------------msg1
    @AISMsgType(type = {1}, position = {38,42},function = "printNavStatus")
    private String navStatus;
    @AISMsgType(type = {1}, position = {42,50})
    private String rateOfROT; //RateOfROT
    @AISMsgType(type = {1}, position = {143,145})
    private String specialMT;
    //   -----------------------------------------------msg4
    @AISMsgType(type = {4}, position = {38, 52})
    private String objUTCyear;
    @AISMsgType(type = {4}, position = {52, 56})
    private String objUTCmonth;
    @AISMsgType(type = {4}, position = {56, 61})
    private String objUTCday;
    @AISMsgType(type = {4}, position = {61, 66})
    private String objUTChour;
    @AISMsgType(type = {4}, position = {66, 72})
    private String objUTCminute;
    @AISMsgType(type = {4}, position = {72, 78})
    private String objUTCsecond;
    //   ------------------------------------------------msg5 (and in 19 apart  but 19 is not use)
    @AISMsgType(type = {5}, position = {38, 40},function = {"BitToMMSI"})
    private String objAISversion;
    @AISMsgType(type = {5}, position = {40, 70},function = {"BitToMMSI"})
    private String objIMOnumber;
    /**
     * 呼号
     */
    @AISMsgType(type = {5}, position = {70, 112},function = {"BitToMMSI"})
    @AISMsgTypeMarge(mergeName ="合并24属性",mergeType =24,type = {1},position = {90, 132},function = {"BitToMMSI"})
    private String callSign;
    @AISMsgType(type = {5}, position = {112, 232},function = "name",merge = true)
    @AISMsgTypeMarge(mergeName ="合并24属性",mergeType =24,type = {0},position = {40,160},function = "name")
    private String name;
    @AISMsgType(type = {5}, position = {232, 240},function = {"BitToMMSI"},merge = true)
    @AISMsgTypeMarge(mergeName ="合并24属性",mergeType =24,type = {1},position = {40, 48},function = {"BitToMMSI"})
    private String shipTypeCode;//船舶类型的源代码
    @AISMsgType(type = {5}, position = {232, 240},function = {"MESStoShipType"})
    @AISMsgTypeMarge(mergeName ="合并24属性",mergeType =24,type = {1},position = {40, 48},function = {"MESStoShipType"})
    private String shipType;
    @AISMsgType(type = {5}, position = {240, 270},function = {"setBoatWidth"})
    @AISMsgTypeMarge(mergeName ="合并24属性",mergeType =24,type = {1},position = {132, 162},function = {"setBoatWidth"})
    private Integer boatWidth;
    @AISMsgType(type = {5}, position = {240, 270},function = {"setBoatLength"})
    @AISMsgTypeMarge(mergeName ="合并24属性",mergeType =24,type = {1},position = {132, 162},function = {"setBoatLength"})
    private Integer boatLength;
    @AISMsgType(type = {5}, position = {274, 294},function = {"ETA2DateStr"})
    private String eta;
    @AISMsgType(type = {5}, position = {294, 302},function = {"parseDouble"})
    private Double maxImum; //吃水深度
    @AISMsgType(type = {5}, position = {302, 422},function = {"MESStoShipType"})
    private String destination;
    @AISMsgType(type = {5}, position = {422, 423},function = {"BitToMMSI"})
    private String dte;
    private Date updateTime;

    //   ------------------------------------------------msg18
    @AISMsgType(type = {18}, position = {38, 46})
    private String spare3;
    @AISMsgType(type = {18}, position = {139, 141})
    private String spare11;
    @AISMsgType(type = {18}, position = {141, 142})
    private String objClassBUnitFlag;
    @AISMsgType(type = {18}, position = {142, 143})
    private String objClassBDisplayFlag;
    @AISMsgType(type = {18}, position = {143, 144})
    private String objClassBDSCFlag;
    @AISMsgType(type = {18}, position = {144, 145})
    private String objClassBBandFlag;
    @AISMsgType(type = {18}, position = {145, 146})
    private String objClassBMessageFlag;
    @AISMsgType(type = {18}, position = {146, 147})
    private String objModeFlag;
    @AISMsgType(type = {18}, position = {147, 148})
    private String objRaimFlag;
    @AISMsgType(type = {18}, position = {148, 149})
    private String objCommunicationStateFlag;
}
